--- apps/app_meetme.c	2005-11-10 16:45:02.000000000 -0800
+++ apps/app_meetme.c-dea	2005-11-24 16:38:40.000000000 -0800
@@ -819,9 +827,14 @@
 	char exitcontext[AST_MAX_CONTEXT] = "";
 	char recordingtmp[AST_MAX_EXTENSION] = "";
 	int dtmf;
+	int dyna_buff = CONF_SIZE;
 	ZT_BUFFERINFO bi;
-	char __buf[CONF_SIZE + AST_FRIENDLY_OFFSET];
-	char *buf = __buf + AST_FRIENDLY_OFFSET;
+	char **buf = NULL;
+	size_t rbufsize = CONF_SIZE + AST_FRIENDLY_OFFSET;
+	/*char __buf[CONF_SIZE + AST_FRIENDLY_OFFSET];
+	char *buf = __buf + AST_FRIENDLY_OFFSET; */
+
+	/* buf = alloca((rbufsize)*sizeof(char *)); */
 	
 	if (!user) {
 		ast_log(LOG_ERROR, "Out of memory\n");
@@ -983,7 +996,7 @@
 		}
 		/* Setup buffering information */
 		memset(&bi, 0, sizeof(bi));
-		bi.bufsize = CONF_SIZE/2;
+		bi.bufsize = dyna_buff/2;
 		bi.txbufpolicy = ZT_POLICY_IMMEDIATE;
 		bi.rxbufpolicy = ZT_POLICY_IMMEDIATE;
 		bi.numbufs = audio_buffers;
@@ -1268,6 +1281,12 @@
 				f = ast_read(c);
 				if (!f)
 					break;
+				if ( f->datalen != dyna_buff && (f->datalen !=0 )){
+					dyna_buff = f->datalen;
+				 	ast_log(LOG_NOTICE, "Audio bytes: %d  Buffer size: %d\n", f->datalen, dyna_buff);
+					close(fd);
+					goto zapretry;
+				}
 				if ((f->frametype == AST_FRAME_VOICE) && (f->subclass == AST_FORMAT_SLINEAR)) {
 					if (user->talk.actual)
 						ast_frame_adjust_volume(f, user->talk.actual);
@@ -1493,7 +1512,12 @@
 				}
 				ast_frfree(f);
 			} else if (outfd > -1) {
-				res = read(outfd, buf, CONF_SIZE);
+				if (!buf || (rbufsize < dyna_buff) ){
+					rbufsize = dyna_buff + AST_FRIENDLY_OFFSET - (dyna_buff % AST_FRIENDLY_OFFSET);
+					buf = realloc(buf, (rbufsize+1)*sizeof(char *));
+				 	ast_log(LOG_NOTICE, "Read Buffer size: %d  Write Buffer size: %d\n", rbufsize, dyna_buff);
+				}
+				res = read(outfd, buf, dyna_buff);
 				if (res > 0) {
 					memset(&fr, 0, sizeof(fr));
 					fr.frametype = AST_FRAME_VOICE;
